public class ArrayList {
  public int size;
  public Object[] list;
  
  //@ ensures size == -1 && list.length == 10; // (1) correct, (2) unnecessary
  public ArrayList() {
    size = -1;
    list = new Object[10];
  }
  
  //@ ensures \result == size; // (1) correct
  public int size() {
    return size;
  }
  
  //@ requires 0 <= index && index <= size; // (1) correct, (2) correct
  //@ ensures \result == list[index]; // (1) correct
  //@ signals (IndexOutOfBoundsException) index < 0 || index > size; // (1) wrong
  public Object get(int index) {
    if (0 <= index && index <= size) {
      return list[index];
    } else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  //@ ensures \result == (\exists int i; 0 <= i && i <= size; list[i] == o); // (1) correct
  public boolean contains(Object o) {
    for (int i = 0; i <= size; i++) {
      if (list[i] == o) {
        return true;
      }
    }
    return false;
  }
  
  //@ requires 0 <= index && index <= size; // (1) correct, (2) correct
  //@ assignable list[index]; // (1) correct
  //@ signals (IndexOutOfBoundsException) index < 0 || index > size; // (1) wrong
  public void set(int index, Object o) {
    if (0 <= index && index <= size) {
      list[index] = o;
    } else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  //@ private behavior // (1) correct
  //@ assignable list; // (1) correct
  //@ ensures (\forall int i; 0 <= i && i <= size; list[i] == \old(list[i])) && list.length == \old(list.length) + 10; // (1) correct, (2) wrong
  private void enlarge() {
    Object[] newList;
    if (list.length >= Integer.MAX_VALUE-10 && list.length < Integer.MAX_VALUE) {
      newList = new Object[Integer.MAX_VALUE];
    } else {
      newList = new Object[list.length + 10];
    }
    for (int i = 0; i <= size; i++) {
      newList[i] = list[i];
    }
    list = newList;
  }
  
  //@ requires size < Integer.MAX_VALUE - 1; // (1) correct
  //@ assignable size, list; // (1) wrong (missing list[*])
  //@ ensures size == \old(size) + 1 && list[size] == o; // (1) correct, (2) correct
  //@ signals (IndexOutOfBoundsException) size == Integer.MAX_VALUE - 1; // (1) wrong
  public void add(Object o) {
    if (size == Integer.MAX_VALUE - 1) {
      throw new IndexOutOfBoundsException();
    }
    if (size == list.length - 1) {
      enlarge();
    }
    size = size + 1;
    list[size] = o;
  }
  
  //@ assignable size, list; // (1) wrong (list should be list[*])
  //@ ensures (\exists int i; 0 <= i && i <= \old(size); \old(list[i]) == o) ==> (size == \old(size) - 1) && (\forall int j; i <= j && j < \old(size); list[j] == \old(list[j + 1])); // Annotated for the two separate a ==> b clauses: (1) correct, (2) correct (size instead of \old(size) in \forall range in verified example)
  //@ ensures (!(\exists int i; 0 <= i && i <= \old(size); \old(list[i]) == o)) ==> size == \old(size); // (1) correct
  public void remove(Object o) {
    for (int i = 0; i <= size; i++) {
      if (list[i] == o) {
        for (int j = i; j < size; j++) {
          list[j] = list[j+1];
        }
        size = size - 1;
        return;
      }
    }
  }