public class BinarySearchGood {
    
    //@ requires (\forall int i, j; 0 <= i && i < j && j < sortedArray.length; sortedArray[i] <= sortedArray[j]); // (1) correct
    //@ ensures (\result >= 0 && sortedArray[\result] == value) || (\result == -1 && (\forall int i; 0 <= i && i < sortedArray.length; sortedArray[i] != value)); // (1) correct
    public static int search(int[] sortedArray, int value) {
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}