public class Counter {
  public int value;

  //@ ensures value == 0; // (1) correct
  public Counter() {
    value = 0;
  }
  
  //@ ensures value == initialValue; // (1) correct
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  //@ assignable value; // (1) correct
  //@ ensures value == \old(value) + 1; // (1) correct
  public void incr() {
    value = value + 1;
  }
  
  //@ requires n >= 0; // (1) correct
  //@ assignable value; // (1) correct
  //@ ensures value == \old(value) + n; // (1) correct
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      incr();
      tmp = tmp - 1;
    }
  }
  
  //@ assignable value; // (1) correct
  //@ ensures value == \old(value) - 1; // (1) correct
  public void decr() {
    value = value - 1;
  }
  
  //@ requires n >= 0; // (1) correct
  //@ assignable value; // (1) correct
  //@ ensures value == \old(value) - n; // (1) correct
  public void decrByN(int n) {
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  //@ ensures \result == value; // (1) correct
  public int get() {
    return value;
  }
  
  //@ assignable value; // (1) correct
  //@ ensures value == n; // (1) correct
  public void set(int n) {
    value = n;
  }
  
}