// Prompt: I have some Java code, can you annotate this program with JML (java modelling language) Specifications.

/*@ public invariant this.value >= 0; @*/

public class Counter {
  public int value;

  //@ ensures this.value == 0;
  public Counter() {
    value = 0;
  }
  
  /*@ requires initialValue >= 0;
      ensures this.value == initialValue;
  @*/
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  /*@ requires value > 0;
      ensures this.value == \old(value) - 1;
  @*/
  public void decr() {
    value = value - 1;
  }
  
  /*@ requires n >= 0;
      ensures \result == 0;
  @*/
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      tmp = tmp - 1;
    }
  }
  
  /*@ requires value > 0;
      ensures this.value == \old(value) - 1;
  @*/
  public void decrByN() {
    value = value - 1;
  }
  
  /*@ requires this.value >= 5;
      ensures this.value == \old(value) - 5;
  @*/
  public void decrByN() {
    int n = 5;
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  /*@ ensures \result == this.value; @*/
  public int get() {
    return value;
  }
  
  /*@ requires n >= 0;
      ensures this.value == n;
  @*/
  public void set(int n) {
    value = n;
  }
  
}
