// Prompt: I have some Java code, can you annotate this program with JML (java modelling language) Specifications without modifying the original code.

//@ pure
public class Counter {
  /*@ spec_public @*/ public int value;

  //@ ensures value == 0;
  public Counter() {
    value = 0;
  }

  /*@ requires initialValue >= 0;
      ensures value == initialValue;
  */
  public Counter(int initialValue) {
    value = initialValue;
  }

  /*@ ensures value == \old(value) + 1;
  */
  public void incr() {
    value = value + 1;
  }
  
  /*@ requires n >= 0;
      ensures \result == n;
  */
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      tmp = tmp - 1;
    }
  }
  
  /*@ ensures value == \old(value) - 1;
  */
  public void decr() {
    value = value - 1;
  }
  
  /*@ ensures value == \old(value) - 5;
  */
  public void decrByFive() {
    int n = 5;
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  //@ ensures \result == value;
  public int get() {
    return value;
  }

  /*@ requires n >= 0;
      ensures value == n;
  */
  public void set(int n) {
    value = n;
  }
}
