package search;

/**
* This version of the file has an added dummy method to be able to infer loop invariants.
* This workaround was described in Daikon's documentation: https://plse.cs.washington.edu/daikon/download/doc/daikon.html#Loop-invariants
*/

public class BinarySearchGood {
    
    public static int search(int[] sortedArray, int value) {
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        while (lo <= hi) {
            dummy_call(lo, hi, sortedArray, value);
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
    
    public static void dummy_call(int lo, int hi, int[] sortedArray, int value) {
    }
}
