// Verified with OpenJML-0.17.0-alpha-14, command: "./openjml --esc --progress path/to/Counter.java"
// OpenJML then shows that all method assertions were validated

package basic;

public class Counter {
  public int value;

  public Counter() {
    value = 0;
  }
  
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  public void incr() {
    value = value + 1;
  }
  
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      dummy_call_loop_invariants_incrByN(tmp, value, n);
      incr();
      tmp = tmp - 1;
    }
  }
  public void dummy_call_loop_invariants_incrByN(int tmp, int value, int n) {
    }
  
  public void decr() {
    value = value - 1;
  }
  
  public void decrByN(int n) {
    int tmp = 0;
    while (tmp < n) {
      dummy_call_loop_invariants_decrByN(tmp, value, n);
      decr();
      tmp = tmp + 1;
    }
  }
  public void dummy_call_loop_invariants_decrByN(int tmp, int value, int n) {
    }

  public int get() {
    return value;
  }
  
  public void set(int n) {
    value = n;
  }
  
}