// Toradocu/JDoctor derives annotations based on the Javadoc
// We have used the List (Java SE 8) JavaDoc as a starting point for this class
// Link to List (Java SE 8)'s JavaDoc: https://docs.oracle.com/javase/8/docs/api/java/util/List.html#contains-java.lang.Object-
// Specifically used the 'contains' method as inspiration

public class BinarySearchGood {
    
  /** Returns true if the array contains the specified value.
    * @param sortedArray array to be searched for the specified value
    * @param value value whose presence in the array is to be tested 
    * @return true if the specified value occurs in the given array
    */
    public static int search(int[] sortedArray, int value) {
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}
