// Toradocu/JDoctor derives annotations based on the Javadoc


public class Counter {
  public int value;

  /** Constructs a counter with an initial value of zero.
    */
  public Counter() {
    value = 0;
  }
  
  /** Constructs a counter with the specified initial value.
    * @param initialValue the initial value to start the counter on
    */
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  /** Increases the counter's value by one.
    */
  public void incr() {
    value = value + 1;
  }
  
  /** Increases the counter's value by the specified amount.
    * @param n positive amount by which the counter should be increased
    */
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      incr();
      tmp = tmp - 1;
    }
  }
  
  /** Decreases the counter's value by one.
    */
  public void decr() {
    value = value - 1;
  }
  
  /** Decreases the counter's value by the specified amount.
    * @param n positive amount by which the counter should be decreased
    */
  public void decrByN(int n) {
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  /** Returns the value of the counter.
    * @return the value of the counter
    */
  public int get() {
    return value;
  }
  
  /** Sets the value of the counter to the specified  value.
    * @param n the value to set the counter to
    */
  public void set(int n) {
    value = n;
  }
  
}