# README generated-annotations/ directory
In this directory you can find the specifications that were generated with various specifications inference tools as well as the input that was used to generate them.

We used the following tools to generate specifications:
ChatGPT with GPT-3.5 and GPT-4
Daikon v5.8.16
EvoSpex commit b2ad83f
Strongarm
Toradocu/Jdoctor commit d76899f

Each tool has a corresponding directory with the input that was used for inference and the generated output.

After inference, each file containing inferred specifications was annotated (manually) to indicate whether the generated specifications are necessary for verification. If a line of specification contains multiple clauses (e.g. requires a && b), then a line is annotated once for each clause. This is done in the same order as the clauses occur. Each line of specification is annotated to indicate whether the line is:
- correct (and also used in the verified baseline examples)
- unnecessary (correct, but not used in the verified baseline examples)
- wrong (incorrect and not used in the verified baseline examples)
The baseline examples should be located in the verified-programs/ directory which should be in the same directory as this (generated-annotations) directory.

E.g. the line:
//@ ensures size == -1 && list.length == 10;
is changed into
//@ ensures size == -1 && list.length == 10; // (1) correct, (2) unnecessary
where (1) refers to the size == -1 clause, and (2) refers to the list.length == 10 clause.


## Overview of files in this directory
- ChatGPT/ contains the input used for inference with ChatGPT and the corresponding output
- Daikon/ contains the input used for inference with Daikon and the corresponding output
- EvoSpex/ contains the input used for inference with EvoSpex and the corersponding output
- Jdoctor/Toradocu contains the input used for inference with Toradocu and the corresponding output
- Strongarm contains the input used for inference with Strongarm and the corresponding output
- count-overlap-with-baseline-verified-examples.html shows a table that indicates whether the specification inference tools generated specifications that were equal/equivalent to the specifications found in the baseline programs
- stats-generated-specs.txt gives an overview of how many specifications were used for the baseline example and how many specifications were inferred by each tool. This is then broken down into whether they are correct/unnecessary/wrong.