// The specs were inferred with Strongarm (in VM, default settings, provided by John Singleton)
// Preconditions in "//@" were provided to Strongarm.
// Note: Some preconditions had to be rewritten as Strongarm does not seem to support i < j < k expressions.

public class BinarySearchGood {
    
    //@ requires sortedArray != null;
    //@ requires 0 < sortedArray.length < Integer.MAX_VALUE;
    //@ requires \forall int i,j; 0 <= i < j < sortedArray.length; sortedArray[i] <= sortedArray[j];
    /*+INFERRED@
      @ public normal_behavior
      @   requires sortedArray != null;
      @   requires 0 < sortedArray.length && sortedArray.length < Integer.MAX_VALUE;
      @   requires \forall int i, int j; 0 <= i && i < j && j < sortedArray.length; sortedArray[i] <= sortedArray[j];
      @   {|
      @     requires !(value < sortedArray[0]);
      @     ensures \result == -1;
      @     {|
      @       requires (value > sortedArray[sortedArray.length - 1]);
      @     also
      @       requires !(0 <= sortedArray.length - 1);
      @       requires !(value > sortedArray[sortedArray.length - 1]);
      @     |}
      @   also
      @     requires (value < sortedArray[0]);
      @     ensures \result == -1;
      @   |}
      @*/
    public static int search(int[] sortedArray, int value) {
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}
