public class BinarySearchGood {
    
    /*+INFERRED@
      @ public normal_behavior // (1) unnecessary
      @   {|
      @     requires !(value < sortedArray[0]); // (1) unnecessary
      @     ensures \result == -1; // (1) correct, in combination with other clauses
      @     {|
      @       requires (value > sortedArray[sortedArray.length - 1]); // (1) unnecessary
      @     also // (1) unnecessary
      @       requires !(0 <= sortedArray.length - 1); // (1) unnecessary
      @       requires !(value > sortedArray[sortedArray.length - 2]); // (1) unnecessary
      @     |}
      @   also // (1) unnecessary
      @     requires (value < sortedArray[0]); // (1) unnecessary
      @     ensures \result == -1; // (1) correct, in combination with other clauses
      @   |}
      @*/
    public static int search(int[] sortedArray, int value) {
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}


// Desugared contract for reference (not generated!):
/*@
@ public normal_behavior
@     requires (value >= sortedArray[0]); // value is bigger than first element
      requires value > sortedArray[sortedArray.length - 1] // value is bigger than last element (so not in array)
@     ensures \result == -1;
@ also
  public normal_behavior
@     requires (value >= sortedArray[0]); (value is bigger than first element)
      requires 0 > sortedArray.length - 1 // length of the array is negative
      requires value <= sortedArray[sortedArray.length - 2] 
@     ensures \result == -1;
also
public bormal_behavior
@     requires (value < sortedArray[0]); value is less than first element
@     ensures \result == -1;
@   |}
*/