// Verified with OpenJML-0.17.0-alpha-14, command: "./openjml --esc --progress path/to/Counter.java"
// OpenJML then shows that all method assertions were validated

public class Counter {
  public int value;

  public Counter() {
    value = 0;
  }
  
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  
  /*+INFERRED@
    @ public normal_behavior // (1) unnecessary
    @   ensures this.value == \old(this.value) + 1; // (1) correct
    @   assignable this.value; // (1) correct
    @*/
  public void incr() {
    value = value + 1;
  }
  
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      incr();
      tmp = tmp - 1;
    }
  }
  
  /*+INFERRED@
    @ public normal_behavior // (1) unnecessary
    @   ensures this.value == \old(this.value) - 1; // (1) correct
    @   assignable this.value; // (1) correct
    @*/
  public void decr() {
    value = value - 1;
  }
  
  public void decrByN(int n) {
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  /*+INFERRED@
    @ public normal_behavior // (1) unnecessary
    @   ensures \result == this.value; // (1) correct
    @*/
  public int get() {
    return value;
  }

  /*+INFERRED@
    @ public normal_behavior // (1) unnecessary
    @   ensures this.value == n; // (1) correct
    @   assignable this.value; // (1) correct
    @*/
  public void set(int n) {
    value = n;
  }
  
}